#include "main.h"
//------------------------------------------------
static const char *TAG = "main";
//------------------------------------------------
//------------------------------------------------
static void task1(void* arg)
{
  SemaphoreHandle_t mutex = (SemaphoreHandle_t) arg;
  uint16_t cnt = 0;
  char str1[10] = {0};
  for(;;) {
    sprintf(str1,"%05d",cnt);
    xSemaphoreTake(mutex, portMAX_DELAY);
    LCD_SetPos(0,0);
    LCD_String(str1);
    xSemaphoreGive(mutex);
    vTaskDelay(1000 / portTICK_PERIOD_MS);
    cnt++;
  }
}
//------------------------------------------------
static void task2(void* arg)
{
  SemaphoreHandle_t mutex = (SemaphoreHandle_t) arg;
  uint16_t cnt = 0;
  char str1[10] = {0};
  for(;;) {
    sprintf(str1,"%05d",cnt);
    xSemaphoreTake(mutex, portMAX_DELAY);
    LCD_SetPos(0,1);
    LCD_String(str1);
    xSemaphoreGive(mutex);
    vTaskDelay(900 / portTICK_PERIOD_MS);
    cnt++;
  }
}
//------------------------------------------------
static void task3(void* arg)
{
  SemaphoreHandle_t mutex = (SemaphoreHandle_t) arg;
  uint16_t cnt = 0;
  char str1[10] = {0};
  for(;;) {
    sprintf(str1,"%05d",cnt);
    xSemaphoreTake(mutex, portMAX_DELAY);
    LCD_SetPos(0,2);
    LCD_String(str1);
    xSemaphoreGive(mutex);
    vTaskDelay(800 / portTICK_PERIOD_MS);
    cnt++;
  }
}
//------------------------------------------------
static void task4(void* arg)
{
  SemaphoreHandle_t mutex = (SemaphoreHandle_t) arg;
  uint16_t cnt = 0;
  char str1[10] = {0};
  for(;;) {
    sprintf(str1,"%05d",cnt);
    xSemaphoreTake(mutex, portMAX_DELAY);
    LCD_SetPos(0,3);
    LCD_String(str1);
    xSemaphoreGive(mutex);
    vTaskDelay(700 / portTICK_PERIOD_MS);
    cnt++;
  }
}
//------------------------------------------------
void app_main(void)
{
  esp_err_t ret;
  ret = i2c_ini();
  ESP_LOGI(TAG, "i2c_ini: %d", ret);
  LCD_ini();
  SemaphoreHandle_t mutex = xSemaphoreCreateMutex();
  vTaskDelay(100 / portTICK_PERIOD_MS);
  xTaskCreate(task1, "task1", 2048, mutex, 5, NULL);
  vTaskDelay(100 / portTICK_PERIOD_MS);
  xTaskCreate(task2, "task2", 2048, mutex, 5, NULL);
  vTaskDelay(100 / portTICK_PERIOD_MS);
  xTaskCreate(task3, "task3", 2048, mutex, 5, NULL);
  vTaskDelay(100 / portTICK_PERIOD_MS);
  xTaskCreate(task4, "task4", 2048, mutex, 5, NULL);
  while (1) {
    vTaskDelay(100 / portTICK_PERIOD_MS);
  }
}
//------------------------------------------------
